<?php
/*
+--------------------------------------------------------------------------------------------------=
|	Quote Retriever - Revidian Development e107 Plugin
|
|	admin_config.php
|	
|	©2010 Revidian Enterprises
|	http://RevidianDev.com
|	devTeam@revidian.com
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
|
|	Author: Revidian Development
|	Created: 10/12/2009
|
|	Updated: 08/25/2010
+--------------------------------------------------------------------------------------------------+
*/

// Pending Removal -------------------------------------------------------
//require_once(e_HANDLER."ren_help.php");
//require_once(e_HANDLER."form_handler.php");
//$rs = new form;
//------------------------------------------------------------------------


//--- Page Management Functions -------------------------------------------------------------------=
//
//	The following functions are used for pages. There are a few function types used.
//
//		Display functions - are used to generate the HTML (usually through templates) that a page 
//			needs and then display it.
//
//		Process functions - are used to receive POST data from a form page. They usually format 
//			data, error check data, and ultimately save it to the database.
//
//		Generate functions - create small snippits of HTML used in templates. This is usually done
//			to create dropdowns or table rows dynamically and preloaded with info from the
//			database. Example uses are dropdowns (selects), table rows, or any repeated data that
//			should have database info inside it.
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//
// Display Functions
//
//------------------------------------------------------------------------
/*
 * Displays the configuration page. This is an admin page that allows the user to alter the location
 * of the quote.txt files.
 */
function displayConfigPage(){
	
	global $page_message, $pageid, $pref;
	
	$pageid = "admin_menu_01"; // tells the admin menu which menu item to hilite
	
	$HTML = capturePHPOutput("tpl/admin_config_tpl.php");
	
	displayPage(RED_QR_CONFIG_00, $HTML);
}

/*
 * Used by all the other display functions to actually have e107 display the content. Displays a 
 * page_message if neccessary, then displays the caption/text.
 *
 * @param String $caption - the caption/title of the page to display. Defaults to the name of the plugin
 * @param String $text    - the text to display in the page
 */
function displayPage($caption = RED_QR_NAME, $text){

	global $ns, $page_message;
	
	//
	// Display page_message if it exist
	//
	if(isset($page_message)){
	
		$ns->tablerender("", "<div style='text-align:center'><b>".$page_message."</b></div>");
	}
	
	$ns->tablerender($caption, $text);
	
	require_once(e_ADMIN.'footer.php');
}
//------------------------------------------------------------------------
//
// Process Functions
//
//------------------------------------------------------------------------
/*
 * Processes the configuration page. Takes the quote.txt location and saves it to the e107 preferences
 * setting.
 */
function processConfigPage(){

	global $page_message, $pref;
	
	$pref['red_qr_location'] = $_POST['location'];
	
	save_prefs(); // automatically runs $tp->toDB on every posted pref before saving 
	// above learned from nlstart's EasyGallery plugin
	
	$page_message = "Saved successfully. ";
	
	displayConfigPage();
}

//------------------------------------------------------------------------
//
// Generate Functions
//
//------------------------------------------------------------------------
/*                                              none here                                         */
//-------------------------------------------------------------------------------------------------+


/*
 * Captures what normally would be displayed in a browser, and returns it. Anything echoed to the 
 * browser, HTML, etc will be captured and returned by this function.
 *
 * @param String filename - the filepath of the PHP file to include
 *
 * @return String - the contents of the captured output. Returns false if not a file.
 */
function capturePHPOutput($file){

	global $pref;
	
	if(!is_file($file)){
	
		return false;
	}
	
	ob_start(); // start capturing output
	
	include($file);
	$contents = ob_get_contents();
	
	ob_end_clean(); // stop capturing output and erase cache
	
	return $contents;
}




//************************************************************************************************//
//****************************************** RUN START *******************************************//
//************************************************************************************************//
//
// Defaults & Defines
//
$page_message = ""; // messages displayed inside a page but above all the content
$eplug_admin = true; // tells class2.php to use the admin theme for this file


require_once("../../class2.php"); // e107 integration


//
// e107 Admin security
//
if(!getperms("P")){ header("location:".e_ADMIN); exit; } // require admin plugin privilidges
require_once(e_ADMIN.'auth.php'); // page header stuff for admins?


require_once("info.php"); // loads general plugin information
include_lan(RED_QR_APATH."lang/".e_LANGUAGE.".php"); // load language file, defaults to English


//--- Paging Logic --------------------------------------------------------------------------------=
//
//------------------------------------------------------------------------
if(isset($_POST['post_mode'])){

	switch($_POST['post_mode']){
		
		case "update_location" :
			processConfigPage();
			break;

		default:
			displayConfigPage();
			break;
	}
}elseif(isset($_GET['m'])){
	
	switch($_GET['m']){
	
		default:
			displayConfigPage();
			break;
	}
}else{ displayConfigPage(); }
//-------------------------------------------------------------------------------------------------+
?>
